﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class FloorScript : MonoBehaviour
{
	private SpriteRenderer sRenderer;
	private Color cNormal;
	public Color PulseColor;

	private float timePassed = 0f;
	public float regeneratingTime = 1.0f;

	void Start()
	{
		StatusManager.Instance.Pulse += Pulse;
		sRenderer = GetComponent<SpriteRenderer>();
		cNormal = sRenderer.color;
	}

	private void Update()
	{
		timePassed += Time.deltaTime;
		if(timePassed > regeneratingTime)
		{
			timePassed = 0f;
		}
		var r = Mathf.Lerp(PulseColor.r, cNormal.r, timePassed / regeneratingTime);
		var g = Mathf.Lerp(PulseColor.g, cNormal.g, timePassed / regeneratingTime);
		var b = Mathf.Lerp(PulseColor.b, cNormal.b, timePassed / regeneratingTime);
		sRenderer.color = new Color(r, g, b);
	}

	private void Pulse()
	{
		if (timePassed < 0.01f)
		{
			sRenderer.color = PulseColor;
		}
	}
}
