﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GenericComplexIObject : IInteractionObject
{
	public float timeLeft = 0;
	public float maxTime = 5.0f;
	public SpriteRenderer Visualizer;
	bool player1;
	bool player2;

	public SpriteRenderer p1Indicator;
	public SpriteRenderer p2Indicator;

	public override bool Active()
	{
		if (timeLeft > 0)
			return true;
		return false;
	}

	public override void Interact(PlayerController sender)
	{
		if(sender != null && sender.playerId == "")
		{
			player1 = true;
			p1Indicator.color = new Color(1f, 0f, 0f);
		}
		else if (sender != null)
		{
			player2 = true;
			p2Indicator.color = new Color(0f, 0f, 1f);
		}
		if (player1 && player2)
		{
			timeLeft = maxTime;
			Visualizer.transform.localPosition = new Vector2(0.75f, Visualizer.transform.localPosition.y);
			p1Indicator.color = new Color(1f, 1f, 1f);
			p2Indicator.color = new Color(1f, 1f, 1f);
			player1 = player2 = false;
		}
	}


	public int StartTime = -1;

	public void Start()
	{
		if (StartTime < 0)
		{
			player1 = player2 = true;
			Interact(null);
		}
	}

	// Update is called once per frame
	void Update()
	{
		timeLeft -= Time.deltaTime;
		Visualizer.transform.localPosition = new Vector2(Mathf.Lerp(
			0.75f,
			-.75f,
			1.0f - (timeLeft / maxTime)),
			Visualizer.transform.localPosition.y);
		if (timeLeft < 0)
			timeLeft = 0;
	}
}
