﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GenericIObject : IInteractionObject
{
	public float timeLeft = 0;
	public float maxTime = 5.0f;
	public GameObject Rotator;

	public Sprite[] PossibleSprites;

	public void Awake()
	{
		var r = GetComponent<SpriteRenderer>();
		r.sprite = PossibleSprites[Random.Range(0, PossibleSprites.Length)];
	}

	public override bool Active()
	{
		if (timeLeft > 0)
			return true;
		return false;
	}

	public override void Interact(PlayerController sender)
	{
		timeLeft = maxTime;
	}

	// Use this for initialization
	void Start ()
	{
		Interact(null);
	}
	
	// Update is called once per frame
	void Update ()
	{
		timeLeft -= Time.deltaTime;
		Rotator.transform.localRotation = Quaternion.Euler(0, 0, -125f + (1.0f - (timeLeft / maxTime)) * 250f);

		if (timeLeft < 0)
			timeLeft = 0;
	}
}
