﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GenericIObjectDispenser : IInteractionObject
{
	public RessourceScript Template;
	public Ressource Ressource;

	public override bool Active()
	{
		return true;
	}

	public override void Interact(PlayerController sender)
	{
		var res = sender.gameObject.GetComponentInChildren(typeof(RessourceScript));
		if(res == null)
		{
			res = Instantiate<RessourceScript>(Template,sender.transform,false);
			res.gameObject.GetComponent<RessourceScript>().Ressource = Ressource;
			res.gameObject.GetComponent<RessourceScript>().CreateColor();


            //transform.SetParent(sender.transform);
            res.GetComponent<Rigidbody2D>().gravityScale = 0;
            foreach (CircleCollider2D col in res.GetComponents<CircleCollider2D>())
                if (col.radius == 0.5f)
                    col.isTrigger = true;
        }
	}

	private void Start()
	{
		ChangeResource(Ressource);
	}

	public Ressource RandomRessource()
	{
		return (Ressource)Random.Range(1,4);
	}

	public void ChangeResource(Ressource r)
	{
		if(r == Ressource.None)
		{
			r = RandomRessource();
		}
		var rend = GetComponent<SpriteRenderer>();
		Ressource = r;
		switch (r)
		{
			case Ressource.BlueBalls:
				rend.sprite = Resources.Load<Sprite>("Sprites/Dispenser3");
				break;
			case Ressource.RedBalls:
				rend.sprite = Resources.Load<Sprite>("Sprites/Dispenser2");
				break;
			case Ressource.YellowBalls:
				rend.sprite = Resources.Load<Sprite>("Sprites/Dispenser1");
				break;
			default:
				break;
		}
	}
}
