﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class LadderController : MonoBehaviour
{

    public Collider2D TopCollider2D;
	public string SortingLayer = "Default";
	public int SortingInLayer = 0;

	private void Start()
	{
		GetComponent<MeshRenderer>().sortingLayerName = SortingLayer;
	}

	void OnTriggerEnter2D(Collider2D collider)
    {
        if (collider.gameObject.CompareTag("player"))
        {
            collider.gameObject.GetComponent<PlayerController>().SetLadder(true);
            Physics2D.IgnoreCollision(collider,TopCollider2D);

            Rigidbody2D rb = collider.GetComponent<Rigidbody2D>();
            rb.velocity = new Vector2(rb.velocity.x, 0);
        }
    }

    void OnTriggerExit2D(Collider2D collider)
    {
        if (collider.gameObject.CompareTag("player"))
        {
            collider.gameObject.GetComponent<PlayerController>().SetLadder(false);
            Physics2D.IgnoreCollision(collider, TopCollider2D,false);
        }
    }
}
