﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MonitorDot : MonoBehaviour
{
	public float original_speed = 0.6f;
	private float speed;
	public float targetPeak = 0.0f;
	public ECDTarget direction = ECDTarget.BASE;

	public enum ECDTarget {  UP, DOWN, BASE}

	// Use this for initialization
	void Start ()
	{
		StatusManager.Instance.Pulse += Pulse;
		speed = original_speed;
	}

	private void Pulse()
	{
		if (original_speed == 0)
		{
			return;
		}
		targetPeak = 0.4f;
		speed = original_speed + Mathf.InverseLerp(0, targetPeak, 0.75f);
		transform.localRotation = Quaternion.Euler(0, 0, 75);
		direction = ECDTarget.UP;
	}

	public bool Handled;

	// Update is called once per frame
	void Update ()
	{
		if(original_speed == 0)
		{
			return;
		}
		transform.Translate(new Vector2(speed * Time.deltaTime, 0f));
		if(direction == ECDTarget.UP && transform.localPosition.y >= targetPeak && original_speed != 0)
		{
			transform.localRotation = Quaternion.Euler(0, 0, -75);
			direction = ECDTarget.DOWN;
			speed = original_speed + Mathf.InverseLerp(0, targetPeak, 0.75f);
			targetPeak = -0.15f;
		}
		else if(direction == ECDTarget.DOWN && transform.localPosition.y <= targetPeak && original_speed != 0)
		{
			transform.localRotation = Quaternion.Euler(0, 0, 70);
			speed = original_speed + Mathf.InverseLerp(0, targetPeak, 0.70f);
			direction = ECDTarget.BASE;
			targetPeak = 0;
		}
		else if(direction == ECDTarget.BASE && transform.localPosition.y >= targetPeak)
		{
			transform.localPosition = new Vector2(transform.localPosition.x, targetPeak);
			transform.localRotation = Quaternion.Euler(0, 0, 0);
			speed = original_speed;
		}
	}

	private void OnDestroy()
	{
		StatusManager.Instance.Pulse -= Pulse;
	}
}
