﻿using UnityEngine;

public enum Ressource { None, RedBalls, BlueBalls, YellowBalls };

public class RessourceScript : IInteractionObject
{
	public Ressource Ressource = Ressource.None;

	public void CreateColor()
	{
		Color c = Color.white;
		switch(Ressource)
		{
			case Ressource.BlueBalls:
				c = Color.blue;
				break;
			case Ressource.RedBalls:
				c = Color.red;
				break;
			case Ressource.YellowBalls:
				c = Color.yellow;
				break;
			default:
				break;
		}
		GetComponent<SpriteRenderer>().color = c;
	}

	public void Remove()
	{
		Destroy(gameObject);
	}

    public override bool Active()
    {
        return true;
    }

    public override void Interact(PlayerController sender)
    {
        var res = sender.gameObject.GetComponentInChildren(typeof(RessourceScript));
        if (res == null)
        {
            transform.SetParent(sender.transform);
            GetComponent<Rigidbody2D>().gravityScale = 0;
            foreach (CircleCollider2D col in GetComponents<CircleCollider2D>())
                if (col.radius == 0.5f)
                    col.isTrigger = true;
        }
    }
}